/*
  Copyright 2004 Feyd
  Copyright 2004, 2005 Jean-Baptiste Note

  This file is part of prism54usb.

  prism54usb is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  prism54usb is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with prism54usb; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

*/

/* 

T:  Bus=01 Lev=01 Prnt=01 Port=03 Cnt=01 Dev#=  2 Spd=480 MxCh= 0
D:  Ver= 2.00 Cls=ff(vend.) Sub=00 Prot=00 MxPS=64 #Cfgs=  1
P:  Vendor=5041 ProdID=2234 Rev= 2.02
C:* #Ifs= 1 Cfg#= 1 Atr=80 MxPwr=500mA
I:  If#= 0 Alt= 0 #EPs=11 Cls=ff(vend.) Sub=00 Prot=00 Driver=(none)
E:  Ad=01(O) Atr=02(Bulk) MxPS= 512 Ivl=0ms
E:  Ad=81(I) Atr=02(Bulk) MxPS= 512 Ivl=0ms
E:  Ad=02(O) Atr=02(Bulk) MxPS= 512 Ivl=0ms
E:  Ad=82(I) Atr=02(Bulk) MxPS= 512 Ivl=0ms
E:  Ad=83(I) Atr=02(Bulk) MxPS= 512 Ivl=0ms
E:  Ad=84(I) Atr=02(Bulk) MxPS= 512 Ivl=0ms
E:  Ad=8d(I) Atr=02(Bulk) MxPS= 512 Ivl=0ms
E:  Ad=0d(O) Atr=02(Bulk) MxPS= 512 Ivl=0ms
E:  Ad=8e(I) Atr=02(Bulk) MxPS= 512 Ivl=0ms
E:  Ad=0e(O) Atr=02(Bulk) MxPS= 512 Ivl=0ms
E:  Ad=8f(I) Atr=03(Int.) MxPS=   4 Ivl=125us

 */
#include <linux/usb.h>

#include "net2280.h"

#define P54U_REG_WSIZE		(sizeof(struct p54u_reg))
#define P54U_REG_RSIZE		(P54U_REG_WSIZE - (sizeof(u32)))

#define P54U_PORT_BRG		0x0010
#define P54U_PORT_BRG_CFG	0x0000
#define P54U_PORT_DEV		0x0800
#define P54U_PORT_DEV_CFG	0x0880
#define P54U_PORT_U16		0x0003
#define P54U_PORT_U32		0x000f

#define P54U_PORT_BRG_U32	(P54U_PORT_BRG | P54U_PORT_U32)
#define P54U_PORT_BRG_CFG_U32	(P54U_PORT_BRG_CFG | P54U_PORT_U32)
#define P54U_PORT_BRG_CFG_U16	(P54U_PORT_BRG_CFG | P54U_PORT_U16)

#define P54U_PORT_DEV_U32	(P54U_PORT_DEV | P54U_PORT_U32)
#define P54U_PORT_DEV_CFG_U32	(P54U_PORT_DEV_CFG | P54U_PORT_U32)
#define P54U_PORT_DEV_CFG_U16	(P54U_PORT_DEV_CFG | P54U_PORT_U16)

/* pci */
#define NET2280_BASE		0x10000000
#define NET2280_BASE2		0x20000000

/* gpio */
#define P54U_BRG_POWER_UP	(1 << GPIO0_DATA)
#define P54U_BRG_POWER_DOWN	(1 << GPIO1_DATA)

/* devinit */
#define NET2280_CLK_4Mhz	(15 << LOCAL_CLOCK_FREQUENCY)
#define NET2280_CLK_30Mhz	(2 << LOCAL_CLOCK_FREQUENCY)
#define NET2280_CLK_60Mhz	(1 << LOCAL_CLOCK_FREQUENCY)
#define NET2280_CLK_STOP	(0 << LOCAL_CLOCK_FREQUENCY)
#define NET2280_PCI_ENABLE	(1 << PCI_ENABLE)
#define NET2280_PCI_SOFT_RESET	(1 << PCI_SOFT_RESET)

/* enpoints */
#define NET2280_CLEAR_NAK_OUT_PACKETS_MODE	(1 << CLEAR_NAK_OUT_PACKETS_MODE)
#define NET2280_FIFO_FLUSH			(1 << FIFO_FLUSH)

/* irq */
#define NET2280_USB_INTERRUPT_ENABLE		(1 << USB_INTERRUPT_ENABLE)
#define NET2280_PCI_INTA_INTERRUPT		(1 << PCI_INTA_INTERRUPT)
#define NET2280_PCI_INTA_INTERRUPT_ENABLE	(1 << PCI_INTA_INTERRUPT_ENABLE)

/* registers */
#define NET2280_DEVINIT		0x00
#define NET2280_USBIRQENB1	0x24
#define NET2280_IRQSTAT1	0x2c
#define NET2280_FIFOCTL         0x38
#define NET2280_GPIOCTL		0x50
#define NET2280_RELNUM		0x88
#define NET2280_EPA_RSP		0x324
#define NET2280_EPA_STAT	0x32c
#define NET2280_EPB_STAT	0x34c
#define NET2280_EPC_RSP		0x364
#define NET2280_EPC_STAT	0x36c
#define NET2280_EPD_STAT	0x38c

#define NET2280_EPA_CFG     0x320
#define NET2280_EPB_CFG     0x340
#define NET2280_EPC_CFG     0x360
#define NET2280_EPD_CFG     0x380
#define NET2280_EPE_CFG     0x3A0
#define NET2280_EPF_CFG     0x3C0


#define P54U_DEV_BASE		0x40000000

#define P54U_TRDY_TIMEOUT	0x40
#define P54U_RETRY_TIMEOUTG	0x41

#define P54U_IMAGE_FILE		"isl3890usb"
#define P54U_IMAGE_FILE_X2	"isl3887usb"

//#define P54U_MAX_FRAME_SIZE	16384
// Where the hell did it come from ??
#define P54U_MAX_FRAME_SIZE	4096
//#define P54U_QUEUE_LEN	16
//FIXME if the queue is too small, this won't work
//#define P54U_QUEUE_LEN		16
// two does not work very well -- there are dropped packets, including
// the auth packets.
// increasing the size seems to be the solution
// 8 should be okay. a state change triggers at most 3-4 packets

#define P54U_QUEUE_LEN          16
#define P54U_FW_BLOCK		512

#define p54u_brg_writel(dev, addr, val)		p54u_reg_rw(dev, 1, P54U_PIPE_BRG, P54U_PORT_BRG_U32, addr, val)
#define p54u_pcicfg_brg_writel(dev, addr, val)	p54u_reg_rw(dev, 1, P54U_PIPE_BRG, P54U_PORT_BRG_CFG_U32, addr, val)
#define p54u_pcicfg_brg_writew(dev, addr, val)	p54u_reg_rw(dev, 1, P54U_PIPE_BRG, P54U_PORT_BRG_CFG_U16, addr, (val & 0xffff))

#define p54u_dev_writel(dev, reg, val)		p54u_reg_rw(dev, 1, P54U_PIPE_DEV, P54U_PORT_DEV_U32, (P54U_DEV_BASE | reg), val)
#define p54u_pcicfg_dev_writel(dev, addr, val)	p54u_reg_rw(dev, 1, P54U_PIPE_DEV, P54U_PORT_DEV_CFG_U32, addr, val)
#define p54u_pcicfg_dev_writew(dev, addr, val)	p54u_reg_rw(dev, 1, P54U_PIPE_DEV, P54U_PORT_DEV_CFG_U16, addr, (val & 0xffff))

#define p54u_brg_readl(dev, addr)		p54u_reg_rw(dev, 0, P54U_PIPE_BRG, P54U_PORT_BRG_U32, addr, 0)
#define p54u_pcicfg_brg_readl(dev, addr)	p54u_reg_rw(dev, 0, P54U_PIPE_BRG, P54U_PORT_BRG_CFG_U32, addr, 0)
#define p54u_pcicfg_brg_readw(dev, addr)	(p54u_reg_rw(dev, 0, P54U_PIPE_BRG, P54U_PORT_BRG_CFG_U16, addr, 0) & 0xffff)

#define p54u_dev_readl(dev, reg)		p54u_reg_rw(dev, 0, P54U_PIPE_DEV, P54U_PORT_DEV_U32, (P54U_DEV_BASE | reg), 0)
#define p54u_pcicfg_dev_readl(dev, addr)	p54u_reg_rw(dev, 0, P54U_PIPE_DEV, P54U_PORT_DEV_CFG_U32, addr, 0)
#define p54u_pcicfg_dev_readw(dev, addr)	(p54u_reg_rw(dev, 0, P54U_PIPE_DEV, P54U_PORT_DEV_CFG_U16, addr, 0) & 0xffff)

/* pipes 3 and 4 are not used by the driver */
#define P54U_PIPE_NUMBER 9

enum p54u_pipe_addr {
        P54U_PIPE_DATA =	0x01,
        P54U_PIPE_MGMT =	0x02,
	P54U_PIPE_3 =		0x03,
        P54U_PIPE_4 =		0x04,
        P54U_PIPE_BRG =		0x0d,
        P54U_PIPE_DEV =		0x0e,
	P54U_PIPE_INT =		0x0f,
};

enum p54u_pipe_index {
	P54U_TX_DATA,
	P54U_TX_MGMT,
	P54U_TX_BRG,
	P54U_TX_DEV,
	P54U_RX_DATA,
	P54U_RX_MGMT,
	P54U_RX_3,
	P54U_RX_4,
	P54U_RX_BRG,
	P54U_RX_DEV,
	P54U_RX_INT,
	P54U_PIPES,
};

enum p54u_state {
	P54U_BOOT,
	P54U_RUN,
	P54U_SHUTDOWN,
	P54U_STOPPED,
};

enum p54u_versions {
	P54U_DEVICE_VER1,
	P54U_DEVICE_VER2,
};

struct p54u_reg {
	u16	port;
	u32	addr;
	u32	val;
} __attribute__ ((packed));

struct p54u_mgmt_tx {
	u32	magic1;
	u32	magic2;
	u32	magic3;
	u16	pos;
	u16	len;
} __attribute__ ((packed));


struct p54u_pipe_desc {
	u8		addr;	/* the address of the endpoint */
	u8		type;	/* the transfer type of the endpoint */
	size_t		p_size;	/* the size of the packet */
	void		(*callback)(struct urb *urb, struct pt_regs *regs);
};


/* RX QUEUES DESCRIPTION 

DATA ORGANIZATION:
   for rx queue we maintain 3 ever-increasing indexes to be interpreted
   modulo the size of the queue, which serves as a ring buffer : f,c,p
   
   - f points to the next frame to be processed by the softmac
     layer. It's modified in driver bottom half => needs locking ?
 
   - c points to the next submitted frame pending usb callback (meaning
     the data it contains will have been written by the device). It's
     modified during the urb callback, in interrupt context.

   - p points to the next free frame. It's modified during frame
     resubmission, after processing the rx'd frames in the bottom half
     => needs locking ?

Initially, a frame is free in the [p,f[ range; its receive buffer is
alloc'd. It is then submitted to the usb layer an goes to the [c,p[
range of submitted but not filled in frames.  Upon urb callback, it
falls into the [f,c[ interval : this frame has been received but its
contents have not yet been processed by the softmac layer. This allows
the callback to return quickly, as it does minimal work. Later, in a
bottom half, the frame will be processed (then its buffer is freed), its
buffer alloc'd, and it will return into the [p,f[ range of free
frames. And resubmitted immediately.

DATA CONTENTS: an element in a rx queue is composed of an urb and an skb
whose data pointer is the receive buffer of the urb.

BUFFER ALLOCATION:

    - the urb are recycled, and allocated once and for all.

    - the softmac layer is in charge of freeing the transfer buffers.
the rx queue mechanism is in charge of allocating the transfer buffers
(on frame free). We could refine this allocation mechanism by allowing
the softmac not to free the transfert buffer.
*/

/* associated functions

rx_queue_refill (refills the queue after processing of the data);
rx_queue_ack (acknowledges a packet);

rx_queue_process : atomically does
 rx_queue_get (get a rx'd buffer);
 rx_queue_free (tell we're done with the rx'd buffer -- refill there ?);

*/

/* TX QUEUES DESCRIPTION
   
DATA ORGANIZATION
   for tx queue we maintain 3 ever-increasing indexes to be interpreted
   modulo the size of the queue, which serves as a ring buffer : f,c,p
   
   - f points to the next frame to be processed by the softmac
     layer.
 
   - c points to the next submitted frame pending usb callback (meaning
     the data it contains will have been received and acknowledged by
     the device). It's modified during the urb callback, in interrupt
     context.

   - p points to the next free frame. It's modified during frame
     submission, after processing, in the bottom half => needs locking ?

Basically f is not really needed here, because the softmac layer does
not process the tx'd frames. We can have only two indexes, f being
always equal to c, for instance ; or always equal to p.

DATA CONTENTS: an element in a rx queue is composed of two urbs, one
with a fixed size, either 32 bits (version 1) or 16 bytes (version 2),
for the announcement message, and a data urb proper, whose transfert
buffer needs to be provided by the upper layer (softmac).

BUFFER ALLOCATION: 

   - the urbs are recycled. The announcement urbs's buffer are recycled
     too. 

   - the tx skb are freed by us upon callback completion.

*/

/* associated functions :

   - submit a tx frame. Argument : skb + u32 (hardware pipe)
   
   - complete tx of a frame

   - refill_tx : free skb of frame (can it be done in the callback, in complete_tx ?)

*/

typedef struct  {
	struct urb     *descr_urb; /* urbs used to send the announced message */
	struct urb     *data_urb;  /* actual data to send */
	struct sk_buff *skb;       /* data buffer */
} usb_command_t;

struct p54u_pipe {
	/* these three should go into a struct */
	usb_command_t   *ringbuf;
	int		len;	/* the length of the ringbufer */

	/* queue management */
	unsigned int    f;
	unsigned int    c;
	unsigned int    p;

	/* bottom half to be run on data rx */
	struct work_struct bh;

	/* usb characteristics :replace with endp descrptor ? */
	u8		addr;	/* the address of the endpoint */
	u8		type;	/* the transfer type of the endpoint */
	size_t          buffer_size; /* the size of the buffer to allocate */
	int             interval;
	int             endp;
};

/* Structure to hold all of our device specific stuff */
struct p54u {
	struct usb_device	*usbdev;	/* save off the usb device pointer */
	struct usb_interface	*interface;	/* save off the usb device pointer */
	struct net_device	*netdev;

	/* running should gicle, state is preferred */
	int			running;
	int                     state;
	int			err;
	
	/* pipes. May be regrouped in an array */
	struct p54u_pipe	data_tx;
	struct p54u_pipe	data_rx;
	struct p54u_pipe	mgmt_tx;
	struct p54u_pipe	mgmt_rx;
	struct p54u_pipe	int_rx;

	/* version-specific handling */
	int                     device_version;
};

extern int load_fw;
extern int islusb_debug;

#define CONFIG_ISLUSB_DEBUG
#ifdef CONFIG_ISLUSB_DEBUG
#define islusb_dbg(format, arg...) if(islusb_debug > 1) printk(format "\n" ,##arg)
#else
#define islusb_dbg(format, arg...)
#endif /* CONFIG_ISLUSB_DEBUG */
#define islusb_info(format, arg...) if(islusb_debug) printk(KERN_INFO __FILE__ ": " format "\n" , ##arg)
#define islusb_warn(format, arg...) printk(KERN_WARN __FILE__ ": " format "\n" , ##arg)
#define islusb_err(format, arg...) printk(KERN_ERR __FILE__ ": " format "\n" ,##arg)

/* device hardware queue management */
void p54u_queue_destroy(struct p54u_pipe *queue);
int p54u_queue_init(struct net_device *netdev, struct usb_endpoint_descriptor *desc, 
		  struct p54u_pipe *queue);
int rx_queue_refill (struct net_device *netdev, struct p54u_pipe *queue);

/* usb transport functions */
int p54u_bulk_msg(struct net_device *netdev, unsigned int ep, void *data, int len);
u32 p54u_reg_rw(struct net_device *netdev, int write, int ep, int port, u32 addr, u32 val);

/* tx callbacks for usb devices */
int tx_submit_ver2 (struct net_device *netdev, struct sk_buff *skb, u32 address);
int tx_submit_ver1 (struct net_device *netdev, struct sk_buff *skb, u32 address);
